// Playground - noun: a place where people can play

import UIKit

class People:NSObject {
    var weight : Double = 0.0
    // （１）値の検証
    override func validateValue(ioValue: AutoreleasingUnsafeMutablePointer<AnyObject?>, forKey inKey: String, error outError: NSErrorPointer) -> Bool {
        if inKey != "weight" { // （2）キー判別
            return false
        }
        if ioValue.memory == nil { // 値が入っているか？
            return false
        }
        let value = ioValue.memory! as Double // Double 型にキャスト
        if value < 200.0 && value > 30.0 { // （3）範囲確認
            return true
        }
        if !(ioValue.memory is Double) {
            // Double ではないのでデフォルト値を返す
            ioValue.memory = 30.0
            return true
        }
        // ここからは範囲外
        if outError != nil { // outError のnil チェック
            outError.memory = NSError(domain: " 範囲外", code: -1, userInfo: [:])
        }
        return false
    }
    
}
var people : People = People()
var error : NSError?
var value : AnyObject? = 20.8
error = nil
// （４）weightの値が20.8で問題ないかバリデーションチェック
people.validateValue(&value, forKeyPath: "weight", error: &error)
println("\(value as Double) \(error?.domain)") // "20.8 Optional("範囲外")"

